﻿#region Copyright Syncfusion Inc. 2001 - 2010
//
//  Copyright Syncfusion Inc. 2001 - 2010. All rights reserved.
//
//  Use of this code is subject to the terms of our license.
//  A copy of the current license can be obtained at any time by e-mailing
//  licensing@syncfusion.com. Any infringement will be prosecuted under
//  applicable laws. 
//
#endregion

using System;
using System.Data;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

using Syncfusion.DocIO;
using Syncfusion.DocIO.DLS;
using System.ComponentModel;
using System.IO;
using System.Drawing;
using System.Data.OleDb;
using System.Text.RegularExpressions;

public partial class _Default : System.Web.UI.Page
{
    
    # region Page Load
    /// <summary>
    /// Handles page load
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void Page_Load(object sender, EventArgs e)
    {
       
    }
    # endregion
    DataSet ds = new DataSet();
    # region Events
    /// <summary>
    /// Creates spreadsheet
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void Button1_Click(object sender, EventArgs e)
    {
        // Load the template.
        WordDocument document = new WordDocument(Server.MapPath(@"App_Data\Template.docx"));

        // Get the tables from Data Set.
        GetDataTable();

        // Using Merge events to do conditional formatting during runtime.
       
        document.MailMerge.MergeImageField += new MergeImageFieldEventHandler(MergeField_ProductImage);
        //Removes the empty paragraph preserved during mail merge.
        document.MailMerge.RemoveEmptyParagraphs = true;
        // Execute Mail Merge with groups.
        document.MailMerge.ExecuteGroup(ds.Tables["Products"]);       
        ds = null;
        ds = new DataSet();

        if (rdButtonWord97To2003.Checked)
        {
            //Save as .doc Word 97-2003 format
            document.Save("Generate Word.doc", FormatType.Doc, Response, HttpContentDisposition.Attachment);
        }
        //Save as .docx Word2007 format
        else if (rdButtonWord2007.Checked)
        {
            try
            {
                document.Save("Generate Word.docx", FormatType.Word2007, Response, HttpContentDisposition.Attachment);
            }
            catch (Win32Exception ex)
            {
                Response.Write("Word 2007 is not installed in this system");
                Console.WriteLine(ex.ToString());
            }
        }
        //Save as .docx Word2010 format
        else if (rdButtonWord2010.Checked)
        {
            try
            {
                document.Save("Generate Word.docx", FormatType.Word2010, Response, HttpContentDisposition.Attachment);
            }
            catch (Win32Exception ex)
            {
                Response.Write("Word 2010 is not installed in this system");
                Console.WriteLine(ex.ToString());
            }
        }
        //Save as .docx Word2013 format
        else if (rdButtonWord2013.Checked)
        {
            try
            {
                document.Save("Generate Word.docx", FormatType.Word2013, Response, HttpContentDisposition.Attachment);
            }
            catch (Win32Exception ex)
            {
                Response.Write("Word 2013 is not installed in this system");
                Console.WriteLine(ex.ToString());
            }
        }
    }

    private void GetDataTable()
    {
        // List of syncfusion products name.
        string[] products = { "Studio", "Chart", "Edit", "Grid", "Tools", "Diagram", "XlsIO", "Grouping", "Calculate", "HTMLUI" };//, "PDF", "DocIO" 

        // Add new Tables to the data set.
        DataRow row;
        ds.Tables.Add();
      
        // Add fields to the Products table.
        ds.Tables[0].TableName = "Products";        

        ds.Tables[0].Columns.Add("ProductImage");
        ds.Tables[0].Columns.Add("ProductName");

        int count = 0;

        // Inserting values to the tables.
        foreach (string product in products)
        {          
            count++;
            row = ds.Tables["Products"].NewRow();           
            row["ProductName"] = string.Concat("Essential ", product);
            if (count < 5)
                row["ProductImage"] = string.Concat(product, ".gif");
            else
                row["ProductImage"] = string.Empty;
            ds.Tables["Products"].Rows.Add(row);
        }
    }   

   
    private void MergeField_ProductImage(object sender, MergeImageFieldEventArgs args)
    {
        // Get the image from disk during Merge.
        if (args.FieldName == "ProductImage" && args.FieldValue != string.Empty)
        {
            string ProductFileName = args.FieldValue.ToString();
            string path = Server.MapPath(@"Images\");
            args.Image = System.Drawing.Image.FromFile(path + ProductFileName);            
        }        
    }   
    # endregion
    #region Helpher Methods
    /// <summary>
    /// Data folder path is resolved from requested page physical path
    /// </summary>
    /// <param name="fileName"></param>
    /// <returns></returns>
    protected string ResolveApplicationDataPath()
    {
        string dataPath = string.Format(Server.MapPath("~/App_Data"));
        return string.Format("{0}", dataPath);
    }
    #endregion
}
